/* MORGAN: Copyright 1991-2005: Univ. of Washington. All rights reserved. */
/* You may copy, use, modify, but NOT redistribute, modified or otherwise.*/
/* See: http://www.stat.washington.edu/thompson/Genepi/license.shtml      */
#include "incs.h"
#include "nghds.h"
#include "markers.h"
#include "rans.h"
#include "msample.h"

#define PMEIO 0.1
#define PIND 0.7
#define PSIB 0.1
#define P3GEN 0.1

/* #define Nhap 1 */

/* variables defined by Liping, Nov, 2005 */

/*
GLOBAL int *hap_status, *hap_index, **hap_allele;
*/

/* The following are functions defined originally in seg_pen.c */
/*
int *group, *first, *next, *alleles[2], *gpflag, *gpsize, **obslist;
int **cpstart, *gplist, *gplist1, ngroups;
double *pp[2];

void change_and_switch_group (int, int);
void change_and_swap_group (int, int);
void change_group (int, int);
*/

/* The following are functions defined originally in gen_pen.c */
/*
struct gp_rfnode **rflist, *free_rfn_list;
struct gp_rfunc_ptr **rfuncs, *free_rfp_list;
struct gp_rfunc *free_rf_list[MAX_GP_RF_GENES], **autozyg_list;
struct deg_list *deglist, **firstlist;
int *gp_inv, *gp_inv1, *gp_flag, *pflag, *rf_idx, **fact, **fact1;
int *ofact, *ofact1, rf_idx_n, *rfxn, **rfx, *cnv_gene;
double *gp_tmp_p, *gp_z;


void free_rfunc (struct gp_rfunc *);
struct gp_rfunc *get_new_rfunc (int, int);
struct gp_rfunc_ptr *get_new_rfptr (void);
struct gp_rfnode *get_new_rfnode (int);
struct gp_rfnode *find_rfnode (int, int);
void delete_rfnode (int, int);
int get_inv_list (int *, int);
void del_rfrow (int);
int calc_degree (int);
void clean_up (int, struct gp_rfunc *);
*/

/* The following are the functions defined by Liping, Jul 10, 2005 */
void al_int_vector (int **, int);
void al_double_vector (double **, int);
void al_int_matrix (int ***, int, int);
void al_double_matrix (double ***, int, int);
void fre_vector (void **);
void fre_matrix (void ***, int);
/*
int     **imatrix(long, long, long, long);
void    free_imatrix(int **, long, long, long, long);
*/


double  fwd_compute2 (int, int, int, double *, int *, double *, double *, double *);
void    back_sample2 (int, int, int, int *, double *, int *, double *, int *);
void    fwd_compute3 (int, int, double *, int *, int *, double *, double *, double *);
int     back_sample3 (int, int, int, int, double *, int *, int *, double *);
void    fwd_compute4 (int, int, int, double *, int *, int *, double *, double *, double *);
int     back_sample4 (int, int, int, int, int, double *, int *, int *, double *);

void    biadd (int *, int m, int n);
double  probtrans (int *, int *, int, double *, int *);
long    int pow2 (int);
void    forward (int, int, double **, double **, double *, int *);
void    backward (int, int, double **, double **, double *, int *);
double  logsum (double, double);

void    sampling2 (int, int, int, int, int, double **);
void    do_msmpl2 (int, int, int, int, int *, int *, double **, int);
int     imin (int, int);

void    update_meiosis (int *, int, int, int, double **, int);
void    update_individual (int *, int, int, int, double **, int);
void    update_sibs (int *, int, int, int, double **, int);
void    update_hmm_sibs(int *, int, int, int, double **, int);
void    update_3generation (int *, int, int, int, double **, int);
void    update_hmm_3generation (int *, int, int, int, double **, int);
void    update_8family (int *, int, int, int, double **, int);

void    obtain_meiosis (int);
void    free_obtain_meiosis (void);
void    change_meiosis(int, int, int, int *, int *, int);
double  find_ptemp(int, int, int, int, int, int *, int *, double **, int, int);

/*
double  seg_pen2_hap (int, double *, int, int, int *);
double  seg_pen_nohap_i(int *, int, int, int, int, int *[2], double *);
double  seg_pen_hap_i(int *, int, int, int, int, int *[2], double *);
double  seg_pen_hap (int, int *[2], double *, int, int, int *);
double  gen_pen_hap (int, int *[2], double *, int, int, int *);

void    sampling_hap (int, int, int, int, int, double **);
void    do_msmpl_hap (int, int, int, int, int *, int *, double **, int);
*/

void calc_lods (int, int, int, int, int, int *, int *, double **, double **, double *);
/*
double calc_lods_hap (int, int, int, int);
*/
/* end of Liping's programs */

