/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/
/* params.h:  Header file for lm_map_w_err.c                        */
/*            Contains the computational parameters used to         */
/*            estimate maps with an error model.                    */
/*                                                                  */
/* Written by WCLS 10/30/05                                         */
/*::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::::*/

   double epsi = 0.02;         /* error rate for initial G          */
   int   NErrorIt = 3;         /* numb of scans per step            */
   int   NSteps = 2;           /* numb of MCEM steps                */
   int   sim = 0;              /* 1 means simul. typing error       */
   int Sxs_werr = 0;           /* 1 means estimate sx-spc maps      */
